Subject: Re: [PATCH] powerpc/cell/axon-msi: retry on missing interrupt

From: Arnd Bergmann <[email-masked]>
Date: Fri, 21 Nov 2008 15:35:42 +0100

On Friday 21 November 2008, Michael Ellerman wrote:
> By incrementing the offset we're dropping the irq. Would it be better to
> just return, and hope that the next time we come in the MSI will have
> landed in the fifo and then we can deliver it? It might be late, really
> late I guess, but that might be better then dropping it altogether.

If this happens, I'd rather treat it as an obvious failure case and make
the device driver hang rather than trying to fix up in case another MSI
comes in. The 100 microseconds should cover any case of really really
late, and if we don't get a valid interrupt here (e.g. because a card
still sends an interrupt after the device driver has unmapped the virq)
looking again at the same position would mean we don't move on to the
next valid one (or have to make the error case more complex).

Also, skipping an invalid interrupt is consistent with what we do right
now. Remember that we can't reliably tell the difference between
'invalid interrupt' and 'no interrupt at all'.

	Arnd <><